function PageLinker(map, aElementId)
{
  this._map = map;
  this._elementId = aElementId;

  PageLinker.url2Map( map );
  
  google.maps.Event.bind( this._map, "maptypechanged", this, this._regenerateUrl );
  google.maps.Event.bind( this._map, "moveend", this, this._regenerateUrl );
  if ( this._map.isLoaded() )
    this._regenerateUrl();
}

PageLinker.getQueryVars = function()
{
  var vars = {};
  var qString = unescape( top.location.search.substring(1) );
  if (qString.length==0)
    return vars;
  var pairs = qString.split(/\&/);
  for (var i=0; i<pairs.length; i++ )
  {
    var nameVal = pairs[i].split(/\=/);
    vars[nameVal[0]] = nameVal[1];
  }
  return vars;
};

PageLinker.map2Url = function( map )
{
  var vars = PageLinker.getQueryVars();
  vars['ll'] = map.getCenter().toUrlValue(5);
  vars['z'] = map.getZoom();
  if ( map.getCurrentMapType()===G_NORMAL_MAP )
    { if (vars['t']) vars['t']=null; }
  else
    vars['t']=map.getCurrentMapType().getUrlArg();

  var url = document.location.protocol+'//'+document.location.hostname+document.location.pathname;
  var bFirst = true;
  for (var key in vars)
  {
    url += bFirst ? "?" : "&";
    bFirst = false;
    url += key;
    if (vars[key]!=null)
      url += "="+vars[key];
  }
  return url;
};

PageLinker.url2Map = function( map )
{
  var vars = PageLinker.getQueryVars();
  if ( !( (vars['z'] && vars['ll']) || vars['t'] ) )
    return;

  var mapType = G_NORMAL_MAP;
  if  (vars['t'])
  for (var i=0; i<map.getMapTypes().length; i++)
    if ( map.getMapTypes()[i].getUrlArg()==vars['t'] )
    {
      mapType = map.getMapTypes()[i];break;
    }
  
  if (vars['z'] && vars['ll'])
  {
    var zoom = parseFloat(vars['z']);
    var ll = vars['ll'].split( "," );
    if (ll.length==2)
    {
      var center = new google.maps.LatLng( ll[0], ll[1] );
      map.setCenter( center, zoom, mapType );
    }
  }
}


PageLinker.prototype = {

_regenerateUrl: function()
{
  var elt = document.getElementById( this._elementId );
  if (!elt) return;
  elt.href = PageLinker.map2Url(this._map);
}

}
